/*
Copyright (c) 2008-2009, Johannes Schlüter
All rights reserved.

Redistribution and use in source and binary forms, with or without modification,
are permitted provided that the following conditions are met:
  * Redistributions of source code must retain the above copyright notice, this
    list of conditions and the following disclaimer.
  * Redistributions in binary form must reproduce the above copyright notice,
    this list of conditions and the following disclaimer in the documentation
    and/or other materials provided with the distribution.
  * Neither the name of Johannes Schlüter nor the names of the contributors may
    be used to endorse or promote products derived from this software without
    specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

This product includes PHP software, freely available from <http://www.php.net/software/>
PHP includes the Zend Engine, freely available at <http://www.zend.com>.
*/
#include "zend.h"
#include "zend_API.h"

zend_class_entry *ce_mysqlstorage_writable;
zend_class_entry *ce_mysqlstorage_updatable;
zend_class_entry *ce_mysqlstorage_deletable;

ZEND_BEGIN_ARG_INFO_EX(arginfo_writable_write, 0, 0, 1)
    ZEND_ARG_INFO(0, data)
ZEND_END_ARG_INFO();

static const zend_function_entry funcs_mysqlstorage_writable[] = {
    ZEND_ABSTRACT_ME( MySQLStorage_Writable, write, arginfo_writable_write)
    {NULL, NULL, NULL}
};

ZEND_BEGIN_ARG_INFO_EX(arginfo_updatable_write, 0, 0, 1)
    ZEND_ARG_INFO(0, data)
ZEND_END_ARG_INFO();

static const zend_function_entry funcs_mysqlstorage_updatable[] = {
    ZEND_ABSTRACT_ME( MySQLStorage_Updatable, update, arginfo_updatable_write)
    {NULL, NULL, NULL}
};

ZEND_BEGIN_ARG_INFO_EX(arginfo_deletable_write, 0, 0, 0)
ZEND_END_ARG_INFO();

static const zend_function_entry funcs_mysqlstorage_deletable[] = {
    ZEND_ABSTRACT_ME( MySQLStorage_Deletable, delete, arginfo_deletable_write)
    {NULL, NULL, NULL}
};

void pse_register_interfaces(TSRMLS_D)
{
     zend_class_entry ce;
     
     INIT_CLASS_ENTRY_EX(ce, "MySQLStorage_Writable", sizeof("MySQLStorage_Writable")-1, funcs_mysqlstorage_writable);
     ce_mysqlstorage_writable = zend_register_internal_interface(&ce TSRMLS_CC);

     INIT_CLASS_ENTRY_EX(ce, "MySQLStorage_Updatable", sizeof("MySQLStorage_Updatable")-1, funcs_mysqlstorage_updatable);
     ce_mysqlstorage_updatable = zend_register_internal_interface(&ce TSRMLS_CC);

     INIT_CLASS_ENTRY_EX(ce, "MySQLStorage_Deletable", sizeof("MySQLStorage_Deletable")-1, funcs_mysqlstorage_deletable);
     ce_mysqlstorage_deletable = zend_register_internal_interface(&ce TSRMLS_CC);
}
